Attribute VB_Name = "Module_FindFirstFile"
Option Explicit
'############################################################################################
    Public Const MAX_PATH = 260
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Public Const FILE_ATTRIBUTE_DIRECTORY = &H10
    Public Const FILE_ATTRIBUTE_HIDDEN = &H2
    Public Const FILE_ATTRIBUTE_ARCHIVE = &H20
    Public Const FILE_ATTRIBUTE_COMPRESSED = &H800
    Public Const FILE_ATTRIBUTE_READONLY = &H1
    Public Const FILE_ATTRIBUTE_SYSTEM = &H4
    Public Const FILE_ATTRIBUTE_TEMPORARY = &H100
    Public Const INVALID_HANDLE_VALUE = -1
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Public Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
    End Type
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Public Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
    End Type
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Public Declare Function FindFirstFile Lib "kernel32" _
        Alias "FindFirstFileA" _
       (ByVal lpFileName As String, _
        lpFindFileData As WIN32_FIND_DATA) _
        As Long
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Public Declare Function FindNextFile Lib "kernel32" _
        Alias "FindNextFileA" _
       (ByVal hFindFile As Long, _
        lpFindFileData As WIN32_FIND_DATA) _
        As Long
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Public Declare Function FindClose Lib "kernel32" _
       (ByVal hFindFile As Long) _
        As Long
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Public Declare Function GetFileAttributes Lib "kernel32" _
        Alias "GetFileAttributesA" _
       (ByVal lpFileName As String) _
        As Long
'############################################################################################
