Attribute VB_Name = "Module_InternetTime"
Option Explicit
'############################################################################################
    Private Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
    End Type
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
    End Type
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Declare Function InternetTimeToSystemTime Lib "wininet.dll" _
       (ByVal lpszTime As String, _
        ByRef pst As SYSTEMTIME, _
        ByVal dwReserved As Long) _
        As Long
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'############################################################################################
'Experimental
Private Declare Function FileTimeToSystemTime Lib "kernel32" _
       (lpFileTime As FILETIME, _
        lpSystemTime As SYSTEMTIME) _
        As Long
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Declare Function MimeOleInetDateToFileTime Lib "inetcomm.dll" _
       (ByVal lpszTime As String, _
        ByRef FT As FILETIME) _
        As Long
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'############################################################################################
Public Function InternetTimeToVBTime(sInternetTime As String) As Date
'********************************************************************************
'Purpose     :Just convert internet date/time to VB Date data type
'Arguments   :string with date/time in internet format such as
'             "Mon, 06 Jul 1998 11:10:46 GMT"
'            :returns a GMT date
'********************************************************************************
    Dim uSystemTime As SYSTEMTIME
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Call InternetTimeToSystemTime(sInternetTime, uSystemTime, 0&)
    With uSystemTime
        InternetTimeToVBTime = CDate(DateSerial(.wYear, .wMonth, .wDay) & " " & _
                                     TimeSerial(.wHour, .wMinute, .wSecond))
    End With
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Public Function MailTimeToVBTime1(sMailTime As String) As Date
    Dim uSystemTime As SYSTEMTIME
    Dim sWWW As String
    Dim dGMT As Long
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sWWW = sMailTime
    If (InStr(1, sWWW, ",") = 0) Then sWWW = "Thu, " & sWWW
    Call InternetTimeToSystemTime(sWWW, uSystemTime, 0&)
    With uSystemTime
        MailTimeToVBTime1 = CDate(DateSerial(.wYear, .wMonth, .wDay) & " " & _
                                  TimeSerial(.wHour, .wMinute, .wSecond))
    End With
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If ((Mid(sWWW, 27, 1) = "-") Or (Mid(sWWW, 27, 1) = "+")) Then dGMT = CInt(Mid(sWWW, 28, 2)) + (CInt(Mid(sWWW, 30, 2)) * 100 / 60)
    If (Mid(sWWW, 27, 1) = "-") Then MailTimeToVBTime1 = DateAdd("H", dGMT, MailTimeToVBTime1)
    If (Mid(sWWW, 27, 1) = "+") Then MailTimeToVBTime1 = DateAdd("H", -dGMT, MailTimeToVBTime1)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Public Function MailTimeToVBTime2(sMailTime As String) As Date
    Dim uFileTime   As FILETIME
    Dim uSystemTime As SYSTEMTIME
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    MimeOleInetDateToFileTime sMailTime, uFileTime
    FileTimeToSystemTime uFileTime, uSystemTime
    With uSystemTime
        MailTimeToVBTime2 = CDate(DateSerial(.wYear, .wMonth, .wDay) & " " & _
                                  TimeSerial(.wHour, .wMinute, .wSecond))
    End With
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################

